unit uROR_Common;
{
================================================================================
*
*       Package:        ROR - Clinical Case Registries
*       Date Created:   $Revision: 50 $  $Modtime: 3/08/07 12:34p $
*       Site:           Hines OIFO
*       Developers:                        @domain.ext
*
*       Description:    Global constants
*
*       Notes:
*
================================================================================
*       $Archive: /CCR v1.5/Current/uROR_Common.pas $
*
* $History: uROR_Common.pas $
 * 
 * *****************  Version 50  *****************
 * User: Vhaishgavris Date: 3/08/07    Time: 1:47p
 * Updated in $/CCR v1.5/Current
 * 
 * *****************  Version 49  *****************
 * User: Vhaishgavris Date: 6/16/06    Time: 3:55p
 * Updated in $/CCR v1.5/Current
 * 
 * *****************  Version 48  *****************
 * User: Vhaishgavris Date: 8/20/05    Time: 4:55p
 * Updated in $/CCR v1.0/Current
 *
 * *****************  Version 46  *****************
 * User: Vhaishgavris Date: 8/19/05    Time: 3:51p
 * Updated in $/CCR v1.0/Current
 *
 * *****************  Version 45  *****************
 * User: Vhaishgavris Date: 8/18/05    Time: 4:56p
 * Updated in $/CCR v1.0/Current
 *
 * *****************  Version 44  *****************
 * User: Vhaishgavris Date: 8/08/05    Time: 3:55p
 * Updated in $/CCR v1.0/Current
 *
 * *****************  Version 43  *****************
 * User: Vhaishgavris Date: 5/17/05    Time: 3:51p
 * Updated in $/CCR v1.0/Current
 *
*
================================================================================
}

interface

uses
  Graphics, oleacc2,
  uROR_Broker, uROR_CCRCmdLine, uROR_Contextor;

const

  /////////////////////////////////// RPC Names \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\

  rpcCDCLoad               = 'RORICR CDC LOAD';
  rpcCDCSave               = 'RORICR CDC SAVE';
  rpcCDCCancel             = 'RORICR CDC CANCEL';

  rpcListLaboratoryTests   = 'ROR LIST LABORATORY TESTS';
  rpcListLocalLabTests     = 'ROR LIST LOCAL LAB TESTS';

  rpcGUIAccess             = 'ROR GUI ACCESS';
  rpcGetRegistryInfo       = 'ROR GET REGISTRY INFO';
  rpcGetRegistryUsers      = 'ROR LIST REGISTRY USERS';
  rpcGetUserInfo           = 'ROR GET USER INFO';
  rpcGUIParameterGet       = 'ROR GUI PARAMETER GET';
  rpcGUIParameterRename    = 'ROR GUI PARAMETER RENAME';
  rpcGUIParameterSet       = 'ROR GUI PARAMETER SET';
  rpcGetMVersion           = 'ROR GET M VERSION';

  rpcListCoordinators      = 'ROR LIST COORDINATORS';
  rpcListDivisions         = 'ROR LIST DIVISIONS';
  rpcListDrugs             = 'ROR LIST DRUGS';
  rpcListRegistryDrugs     = 'ROR LIST REGISTRY DRUGS';
  rpcListInvestigDrugs     = 'ROR LIST INVESTIGATIONAL DRUGS';
  rpcListHospitalLocations = 'ROR LIST HOSPITAL LOCATIONS';
  rpcListICD9              = 'ROR LIST ICD-9';
  rpcListItems             = 'ROR LIST ITEMS';
  rpcListLocalDrugs        = 'ROR LIST LOCAL DRUGS';
  rpcListLocalFields       = 'ROR LIST LOCAL FIELDS';
  rpcListSelectionRules    = 'ROR LIST SELECTION RULES';
  rpcListGenericDrugs      = 'ROR LIST GENERIC DRUGS';
  rpcListPatients          = 'ROR LIST PATIENTS';
  rpcListVistaUsers        = 'ROR LIST VISTA USERS';
  rpcListVADrugClasses     = 'ROR LIST VA DRUG CLASSES';
  rpcLogGetList            = 'ROR LOG GET LIST';
  rpcLogGetMessages        = 'ROR LOG GET MESSAGES';
  rpcLogGetViolations      = 'ROR LOG GET ACCESS VIOLATIONS';
  rpcLogInfo               = 'ROR LOG INFO';

  rpcPatientGetData        = 'ROR PATIENT GET DATA';
  rpcPatientInActivate     = 'ROR PATIENT (IN)ACTIVATE';

  rpcReportRetrieve        = 'ROR REPORT RETRIEVE';
  rpcReportSchedule        = 'ROR REPORT SCHEDULE';
  rpcReportStylesheet      = 'ROR REPORT STYLESHEET';
  rpcReportsAvailable      = 'ROR REPORTS AVAILABLE';

  rpcPatientDelete         = 'ROR PATIENT DELETE';

  rpcStatesList            = 'ROR LIST STATES';
  rpcSupportingEvidence    = 'ROR LIST ITEMS';

  rpcTaskDelete            = 'ROR TASK DELETE';
  rpcTaskInfo              = 'ROR TASK INFO';
  rpcTaskList              = 'ROR TASK LIST';
  rpcTaskValidateRescheduling = 'ROR TASK VALIDATE RESCHEDULING';

  rpcUpdateCoordinators    = 'ROR UPDATE COORDINATORS';
  rpcUpdateLocalDrugs      = 'ROR UPDATE LOCAL DRUGS';
  rpcUpdateLocalFields     = 'ROR UPDATE LOCAL FIELDS';
  rpcUpdateLocalLabTests   = 'ROR UPDATE LOCAL LAB TESTS';

  rpcIsRPCAvailable        = 'XWB IS RPC AVAILABLE';

  rpcCD4CountSave          = rpcUpdateLocalLabTests;

  //////////////////////////// Miscellaneous Constants \\\\\\\\\\\\\\\\\\\\\\\\\

  sReportParamsTemplate = 'ROR REPORT PARAMS TEMPLATE';
  sCoord                = 'COORDINATORS';
  sARVDrugs             = 'ARVDRUGS';

  sCloseHTML            = '</body></html>';
  sOpenHTML             = '<html><body>';

  sCDCLayout            = 'CDCIndex';
  sCDCNavigator         = 'CDCPanelList';
  sCDCTree              = 'CDCPanelListWidth';
  sCDCIndex             = 'CDCIndex';

  U = '^';

  iDefaultActivityTerm = 7;

  UndefinedPatientID = '-1';

type

  TIRMode = (mInactivate, mReactivate);
  TLabGroupCode = (
    lgcHIV_CD4 = 1, lgcHIV_CD4Percent, lgcHIV_VL, lgcHIV_Ab,
    lgcHEPC_Ab = 1, lgcHEPC_RIBA, lgcHEPC_Qual, lgcHEPC_Quant, lgcHEPC_GT
  );

var
  iCDCFontSize: Integer    = 8;

function AccPropServices: IAccPropServices;
function Broker: TCCRBroker;
function CmdLineParams: TCCRCommandLineParameters;
function CCOWContextor: TCCRContextor;

implementation

uses
  fROR_Main;

var
  fAccPropServices: IAccPropServices;

function AccPropServices: IAccPropServices;
begin
  if not Assigned(fAccPropServices) then
    fAccPropServices := CoCAccPropServices.Create;
  Result := fAccPropServices;
end;

function Broker: TCCRBroker;
begin
  if Assigned(FormMain) then
    Result := FormMain.ccrBroker
  else
    Result := nil;
end;

function CmdLineParams: TCCRCommandLineParameters;
begin
  if Assigned(FormMain) then
    Result := FormMain.ccrCmdLineParams
  else
    Result := nil;
end;

function CCOWContextor: TCCRContextor;
begin
  if Assigned(FormMain) then
    Result := FormMain.ccrContextor
  else
    Result := nil;
end;

end.
